local rnd = math.random
function random_bg(x, y)
	local c = rnd(0, 255)
	return c, c, c, 255
end

function random_ball(x, y)
	local xd = x - 100
	local yd = y - 100
	if xd*xd + yd*yd > 9000 then
		return
	end
	local c = rnd(0, 255)
	return c, c, c, 255
end

function love.load()
	bg_d = love.image.newImageData(800, 600)
	bg_d:mapPixel(random_bg)
	bg = love.graphics.newImage(bg_d) --"bg.png"
	ball_d = love.image.newImageData(200, 200)
	ball_d:mapPixel(random_ball)
	ball = love.graphics.newImage(ball_d) --"ball.png"
	enemy_d = love.image.newImageData(50, 50)
	enemy_d:mapPixel(random_bg)
	enemy = love.graphics.newImage(enemy_d) --"enemy.png"
	setup()
end

function setup()
	x = 100
	y = 100
	ex = 400
	ey = 300
	t = 0
	dead = false
	love.graphics.setColor(255, 255, 255)
end

function love.update(dt)
	if love.keyboard.isDown 'escape' then
		love.event.push 'q'
	end
	if won then
		t = t + dt
		if t > 2 then
			t = 0
			bg_d:mapPixel(random_bg)
			bg = love.graphics.newImage(bg_d)
		end
		return
	end
	if not dead then
		local moving = false
		if love.keyboard.isDown 'left' then
			x = x - dt * 25
			moving = true
		end
		if love.keyboard.isDown 'right' then
			x = x + dt * 25
			moving = true
		end
		if love.keyboard.isDown 'up' then
			y = y - dt * 25
			moving = true
		end
		if love.keyboard.isDown 'down' then
			y = y + dt * 25
			moving = true
		end
		t = t + dt
		if t > 4 then
			t = 0
			local amt = math.random(moving and 30 or 2, moving and 60 or 10)
			ex = ex + (x > ex and amt or -amt)
			ey = ey + (y > ey and amt or -amt)
			enemy_d:mapPixel(random_bg)
			enemy = love.graphics.newImage(enemy_d)
		end
		if x < 75 or y < 75 or x > 725 or y > 525 or ((x - ex)^2 + (y - ey)^2) < 10000 then
			love.graphics.setColor(255, 0, 0)
			dead = true
			dead_timer = 0
		end
		if x > 700 and y > 500 then
			love.graphics.setColor(0, 255, 0)
			won = true
			t = -2
		end
	else
		dead_timer = dead_timer + dt
		if dead_timer > 3 then
			bg_d:mapPixel(random_bg)
			bg = love.graphics.newImage(bg_d)
			setup()
		end
	end
end

function love.draw()
	love.graphics.draw(bg, 0, 0)
	love.graphics.draw(ball, math.floor(x) - 100, math.floor(y) - 100)
	love.graphics.draw(enemy, ex - 25, ey - 25)
end
